---
title: scrollbar-gutter
slug: Web/CSS/scrollbar-gutter
tags:
  - CSS
  - Property
  - Reference
  - scrollbar-gutter
---
<div>{{CSSRef}}</div>

<p>The <strong><code>scrollbar-gutter</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property allows authors to reserve space for the scrollbar, preventing unwanted layout changes as the content grows while also avoiding unnecessary visuals when scrolling isn't needed.</p>

<p>An element's <em>scrollbar gutter</em> is the space between the inner border edge and the outer padding edge, where the browser may display a scrollbar. If no scrollbar is present, the gutter will be painted as an extension of the padding.</p>

<p>The browser determines whether <em>classic</em> scrollbars or <em>overlay</em> scrollbars are used:</p>

<ul>
 <li>Classic scrollbars are always placed in a gutter, consuming space when present.</li>
 <li>Overlay scrollbars are placed over the content, not in a gutter, and are usually partially transparent.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Initial value */
scrollbar-gutter: auto;

/* "stable" keyword, with optional modifiers */
scrollbar-gutter: stable;
scrollbar-gutter: stable both;
scrollbar-gutter: stable force;
scrollbar-gutter: stable both force;

/* "always" keyword, with optional modifiers */
scrollbar-gutter: always;
scrollbar-gutter: always both;
scrollbar-gutter: always force;
scrollbar-gutter: always both force;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>The initial value. Classic scrollbars create a gutter when <code>overflow</code> is <code>scroll</code>, or when <code>overflow</code> is <code>auto</code> and the box is overflowing. Overlay scrollbars do not consume space.</dd>
 <dt><code>stable</code></dt>
 <dd>When using classic scrollbars, the gutter will be present if <code>overflow</code> is <code>scroll</code> or <code>auto</code> even if the box is not overflowing. When using overlay scrollbars, the gutter will not be present.</dd>
 <dt><code>always</code></dt>
 <dd>The scrollbar gutter will always be present when <code>overflow</code> is <code>scroll</code> or <code>auto</code>, regardless of the type of scrollbar or of whether the box is overflowing.</dd>
 <dt><code>both</code></dt>
 <dd>If a gutter would be present on one of the inline start/end edges of the box, another will be present on the opposite edge as well.</dd>
 <dt><code>force</code></dt>
 <dd>The keywords <code>stable</code> and <code>always</code> will also be in effect when <code>overflow</code> is <code>visible</code>, <code>hidden</code> or <code>clip</code>. Only the gutter will be displayed, not a scrollbar.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Example_1">Example 1</h3>

<p>Prevent layout changes when the content grows or shrinks:</p>

<pre class="brush: css notranslate">.container {
    scrollbar-gutter: stable;
}
</pre>

<h3 id="Example_2">Example 2</h3>

<p>Prevent an overlay scrollbar from obscuring content:</p>

<pre class="brush: css notranslate">.container {
    scrollbar-gutter: always;
}
</pre>

<h3 id="Example_3">Example 3</h3>

<p>Keep the symmetry between both sides of the box:</p>

<pre class="brush: css notranslate">.container {
    scrollbar-gutter: stable both;
}
</pre>

<h3 id="Example_4">Example 4</h3>

<p>Reserve the same amount of space on the edges of an element that is adjacent to a scrolling element as is being reserved in the latter, so that both line up visually:</p>

<pre class="brush: css notranslate">.header {
    scrollbar-gutter: always force;
}

.container {
    scrollbar-gutter: always;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('CSS4 Overflow', '#scrollbar-gutter-property', 'scrollbar-gutter') }}</td>
   <td>{{ Spec2('CSS Overflow') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.scrollbar-gutter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("scrollbar-width")}}</li>
 <li>{{CSSxRef("overflow")}}</li>
</ul>
